/*------------------------------------------------------------------*/
/* EvoCCs_scatter						    */
/*   Tool for evolutionary design of broadcast-based                */
/*   collective communications on wormhole networks                 */
/*                                                                  */
/* Author: Jiri Jaros						    */
/*	   jarosjir@fit.vutbr.cz                                    */
/* 	   Brno University of Technology			    */
/* 	   GPL Licence, 2010					    */
/*------------------------------------------------------------------*/

/*------------------------------------------------------------------*/
/* MMS.h - Implementation of Many-to-Many scatter communications    */
/*       - header file	                                            */
/*------------------------------------------------------------------*/

#ifndef MMSH
#define MMSH

#include "Chromozome.h"
//#include "../Random.h"
#include "Statistics.h"
#include "GeneticCore.h"
//---------------------------------------------------------------------------
void   MMSOnInitAlgorithm(GeneticCore& GA, int argc, char** argv);
void   MMSInitChromozome(Chromozome &chr);

double MMSComputeFitness(Chromozome& chr);
void   MMSMutation(Chromozome& chr);

void   MMSOnFinishGeneration(Statistics Stat, int ActGeneration);
void   MMSOnFinish(Statistics Stat, int ActGeneration);

#endif

